#include	"../DLL/d_iNES.h"
#include	"../Hardware/h_74xx.h"

static	void	Sync (void)
{
	MP->SetPRG_ROM16(0x8,-1);
	MP->SetPRG_ROM16(0xC,_74xx.Data & 0xF);
	MP->SetCHR_RAM8(0,0);
	switch ((_74xx.Data >> 6) & 0x3)
	{
	case 0:	/* MP->Mirror_S0();
		/* uncertain */		break;
	case 1:	MP->Mirror_H();		break;
	case 2:	MP->Mirror_V();		break;
	case 3:	/* MP->Mirror_S1();
		/* uncertain */		break;
	}
}

static	void	__cdecl	SaveMI (Ar128 MI)
{
	_74xx_SaveMI_D(MI,0);
}

static	void	__cdecl	LoadMI (const Ar128 MI)
{
	_74xx_LoadMI_D(MI,0);
}

static	void	__cdecl	UnloadMapper (void)
{
	iNES_UnloadROM();
	_74xx_Destroy();
}

static	void	__cdecl	InitMapper (const PMapperParam _MP, int IsHardReset)
{
	MP = _MP;
	iNES_InitROM();
	_74xx_Init(Sync,IsHardReset,FALSE);
}

CTMapperInfo	MapperInfo_097 =
{
	"Kid Niki (J)",
	97,
	MS_Full,
	16384,
	InitMapper,
	UnloadMapper,
	NULL,
	NULL,
	SaveMI,
	LoadMI,
	NULL,
	NULL
};
